package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryConfirmStatusDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryConfirmStatusDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryConfirmStatusDao;
import com.friday.custody.entity.DataDictionaryConfirmStatusEntity;
import com.friday.custody.service.basicService.DataDictionaryConfirmStatusService;
import org.springframework.util.CollectionUtils;


@Service("dataDictionaryConfirmStatusService")
public class DataDictionaryConfirmStatusServiceImpl extends ServiceImpl<DataDictionaryConfirmStatusDao, DataDictionaryConfirmStatusEntity>
        implements DataDictionaryConfirmStatusService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryConfirmStatusEntity> page = this.page(
                new Query<DataDictionaryConfirmStatusEntity>().getPage(params),
                new QueryWrapper<DataDictionaryConfirmStatusEntity>()
        );

        return new PageUtils(page);
    }

    @Autowired
    private DataDictionaryConfirmStatusDetailsService detailsService;
    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryConfirmStatusEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryConfirmStatusDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryConfirmStatusDetailsEntity::getOriginValue, DataDictionaryConfirmStatusDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryConfirmStatusEntity::getId, DataDictionaryConfirmStatusEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryConfirmStatusDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryConfirmStatusEntity 查询失败！");
        }
        return result;
    }
    @Override
    public R queryData(String type) {
        List<DataDictionaryConfirmStatusEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryConfirmStatusEntity::getKeyStr
                            ,DataDictionaryConfirmStatusEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }

}